SizeFileComparator (Commons IO 2.5)
Date: 2016-12-01

org.apache.commons.io.comparator

## Class SizeFileComparator

- java.lang.Object
- - org.apache.commons.io.comparator.AbstractFileComparator
  - - org.apache.commons.io.comparator.SizeFileComparator

- All Implemented Interfaces:
    java.io.Serializable, java.util.Comparator<java.io.File>

      public class SizeFileComparator
      extends AbstractFileComparator
      implements java.io.Serializable

  Compare the length/size of two files for order (see `File.length()` and `FileUtils.sizeOfDirectory(File)`).

  This comparator can be used to sort lists or arrays of files by their length/size.

  Example of sorting a list of files using the `SIZE_COMPARATOR` singleton instance:

             List<File> list = ...
             ((AbstractFileComparator) SizeFileComparator.SIZE_COMPARATOR).sort(list);

  Example of doing a reverse sort of an array of files using the `SIZE_REVERSE` singleton instance:

             File[] array = ...
             ((AbstractFileComparator) SizeFileComparator.SIZE_REVERSE).sort(array);

  N.B. Directories are treated as zero size unless `sumDirectoryContents` is `true`.

  Since:
    1.4
  Version:
    $Id: SizeFileComparator.java 1642757 2014-12-01 21:09:30Z sebb $
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static long` | `serialVersionUID`
    `static java.util.Comparator<java.io.File>` | `SIZE_COMPARATOR` Size comparator instance - directories are treated as zero size
    `static java.util.Comparator<java.io.File>` | `SIZE_REVERSE` Reverse size comparator instance - directories are treated as zero size
    `static java.util.Comparator<java.io.File>` | `SIZE_SUMDIR_COMPARATOR` Size comparator instance which sums the size of a directory's contents using `FileUtils.sizeOfDirectory(File)`
    `static java.util.Comparator<java.io.File>` | `SIZE_SUMDIR_REVERSE` Reverse size comparator instance which sums the size of a directory's contents using `FileUtils.sizeOfDirectory(File)`
    `private boolean` | `sumDirectoryContents` Whether the sum of the directory's contents should be calculated.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SizeFileComparator()` Construct a file size comparator instance (directories treated as zero size).
    `SizeFileComparator(boolean sumDirectoryContents)` Construct a file size comparator instance specifying whether the size of the directory contents should be aggregated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(java.io.File file1, java.io.File file2)` Compare the length of two files.
    `java.lang.String` | `toString()` String representation of this file comparator.

    - ### Methods inherited from class org.apache.commons.io.comparator.AbstractFileComparator

      `sort, sort`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `equals`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      See Also:
        Constant Field Values

    - #### SIZE_COMPARATOR

          public static final java.util.Comparator<java.io.File> SIZE_COMPARATOR

      Size comparator instance - directories are treated as zero size

    - #### SIZE_REVERSE

          public static final java.util.Comparator<java.io.File> SIZE_REVERSE

      Reverse size comparator instance - directories are treated as zero size

    - #### SIZE_SUMDIR_COMPARATOR

          public static final java.util.Comparator<java.io.File> SIZE_SUMDIR_COMPARATOR

      Size comparator instance which sums the size of a directory's contents using `FileUtils.sizeOfDirectory(File)`

    - #### SIZE_SUMDIR_REVERSE

          public static final java.util.Comparator<java.io.File> SIZE_SUMDIR_REVERSE

      Reverse size comparator instance which sums the size of a directory's contents using `FileUtils.sizeOfDirectory(File)`

    - #### sumDirectoryContents

          private final boolean sumDirectoryContents

      Whether the sum of the directory's contents should be calculated.

  - ### Constructor Detail

    - #### SizeFileComparator

          public SizeFileComparator()

      Construct a file size comparator instance (directories treated as zero size).

    - #### SizeFileComparator

          public SizeFileComparator(boolean sumDirectoryContents)

      Construct a file size comparator instance specifying whether the size of the directory contents should be aggregated.

      If the `sumDirectoryContents` is `true` The size of directories is calculated using `FileUtils.sizeOfDirectory(File)`.

      Parameters:
        `sumDirectoryContents` - `true` if the sum of the directoryies contents should be calculated, otherwise `false` if directories should be treated as size zero (see `FileUtils.sizeOfDirectory(File)`).

  - ### Method Detail

    - #### compare

          public int compare(java.io.File file1,
                    java.io.File file2)

      Compare the length of two files.
      Specified by:
        `compare` in interface `java.util.Comparator<java.io.File>`
      Parameters:
        `file1` - The first file to compare
        `file2` - The second file to compare
      Returns:
        a negative value if the first file's length is less than the second, zero if the lengths are the same and a positive value if the first files length is greater than the second file.

    - #### toString

          public java.lang.String toString()

      String representation of this file comparator.
      Overrides:
        `toString` in class `AbstractFileComparator`
      Returns:
        String representation of this file comparator

Copyright (c) 2002-2016 Apache Software Foundation